Require MinMJ_LJ.
Require MinMJ_MJ.
Require MinMJ_NJ.
Require MinMJ_Occurs_Lift.

Recursive Definition
    Weaken_Hyps : nat->F->Hyps->Hyps :=
	O P h => (Add_Hyp P h) |
	(S n) P MT => MT |
	(S n) P (Add_Hyp Q h) => (Add_Hyp Q (Weaken_Hyps n P h)).

Lemma In_Weaken_Hyps :
	(i,j:nat)(h:Hyps)(P,Q:F)
	 (lt j (S (Len_Hyps h)))->
	  (In_Hyps i P h)->
	   (In_Hyps (lift_V j i) P (Weaken_Hyps j Q h)).

Definition n_admis_weaken :
	(h:Hyps)(n:N)(P:F)(N_Deduc h n P)->Prop :=
	 [h:Hyps][n:N][P:F][D:(N_Deduc h n P)]
	  (j:nat)(Q:F)
	   (lt j (S (Len_Hyps h)))->
	    (N_Deduc (Weaken_Hyps j Q h) (lift_N j n) P).

Definition a_admis_weaken :
	(h:Hyps)(a:A)(P:F)(A_Deduc h a P)->Prop :=
	 [h:Hyps][a:A][P:F][D:(A_Deduc h a P)]
	  (j:nat)(Q:F)
	   (lt j (S (Len_Hyps h)))->
	    (A_Deduc (Weaken_Hyps j Q h) (lift_A j a) P).

Lemma N_admis_weaken :
	((h:Hyps)(n:N)(R:F)(n0:(N_Deduc h n R))(n_admis_weaken h n R n0))/\
	 ((h:Hyps)(a:A)(R:F)(a0:(A_Deduc h a R))(a_admis_weaken h a R a0)).

Lemma N_Admis_Weaken :
	(h:Hyps)(n:N)(P:F)(j:nat)(Q:F)
	 (N_Deduc h n P)->
	   (lt j (S (Len_Hyps h)))->
	    (N_Deduc (Weaken_Hyps j Q h) (lift_N j n) P).

Lemma A_Admis_Weaken :
	(h:Hyps)(a:A)(P:F)(j:nat)(Q:F)
	 (A_Deduc h a P)->
	   (lt j (S (Len_Hyps h)))->
	    (A_Deduc (Weaken_Hyps j Q h) (lift_A j a) P).

Definition l_admis_weaken :
	(h:Hyps)(l:L)(P:F)(L_Deriv h l P)->Prop :=
	 [h:Hyps][l:L][P:F][D:(L_Deriv h l P)]
	  (j:nat)(Q:F)
	   (lt j (S (Len_Hyps h)))->
	    (L_Deriv (Weaken_Hyps j Q h) (lift_L j l) P).

Lemma L_admis_weaken :
	(h:Hyps)(l:L)(P:F)(D:(L_Deriv h l P))
	 (l_admis_weaken h l P D).

Lemma L_Admis_Weaken :
	(h:Hyps)(l:L)(P,Q:F)(j:nat)
	 (L_Deriv h l P)->
	  (lt j (S (Len_Hyps h)))->
	   (L_Deriv (Weaken_Hyps j Q h) (lift_L j l) P).
